#include<stdlib.h>
#include"hash.h"

void * hash_lookup(const void * const base,int const width,int const size,unsigned const key,int (* const found)(void * const element)) {
         void *element, *pelement;
         int prev,pprev,curr;

         pelement = NULL;
         hashes = 0;
         prev = -1;
         curr = hash(key,size);
         do {
            ++hashes;
            if( found(element = (char *)base + (curr * width)) ) {
               if(pelement) {
                   memswp(pelement,element,width);
                   return pelement;
               }
               else return element;
            }
            pelement = element;
            pprev = prev;
            prev = curr;
            curr = hash(key + hashes + curr,size);
        } while( curr != prev && curr != pprev );
        return NULL;
   }

void **hash_resize(void **base,int const width,int *size,int const newsize,unsigned (* const key)(void * const),int (* const found)(void * const element),int (* const fail)(void * const element)) {
          int oldsize = *size;
          void *element = *base, *newbase = calloc(newsize,width);

          if(newbase == NULL) return NULL;
          while(oldsize > 0) {
               void *newloc = hash_lookup(newbase,width,newsize,key(element),found);
               if(newloc == NULL) {
                   if(fail(element)) {
                      free(newbase);
                      return NULL;
                   }
               }
               else memcpy(newloc,element,width);
               oldsize--;
               element = (char *)element + width;
           }
           free(*base);
           *base = newbase;
           *size = newsize;
           return base;
    }
